package com.shigongli.common;

import com.shigongli.config.ScreenShotConfig;
import org.openqa.selenium.*;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.chrome.ChromeOptions;
import org.openqa.selenium.support.ui.ExpectedCondition;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.File;
import java.util.concurrent.TimeUnit;

@Component
public class ScreenShotUtil {
    @Autowired
    OSSUtils ossUtils;

    @Autowired
    ScreenShotConfig config;

    public String shot(String url, String cssSelector) throws Exception {
        //驱动地址
        System.setProperty("webdriver.chrome.driver", config.getDriver());

        WebDriver webDriver = null;
        ChromeOptions options=new ChromeOptions();
        //设置 chrome 的无头模式
        options.addArguments("--headless");
        options.addArguments("--disable-gpu");
        options.addArguments("--no-sandbox");
        options.addArguments("--disable-dev-shm-usage");
        options.addArguments("--start-maximized");
        options.addArguments("--lang=zh");
        options.addArguments(String.format("--window-size=%s,%s", config.getWidth(), config.getHeight()));
        //启动一个 chrome 实例
        webDriver = new ChromeDriver(options);

        //访问网址
        webDriver.get(url);

        // 设置超时等待
        WebDriverWait webDriverWait = new WebDriverWait(webDriver, config.getWait() / 1000);
        String finalCssSelector = null == cssSelector ? "body" : cssSelector;
        webDriverWait.until(new ExpectedCondition<WebElement>() {
            @Override
            public WebElement apply(WebDriver driver) {
                // 通过定位页面元素来确定页面确实正常加载了
                return driver.findElement(By.cssSelector(finalCssSelector));
            }
        });

//        webDriver.manage().timeouts().implicitlyWait(config.getWait(), TimeUnit.MILLISECONDS);

        //截取全屏
        File f  = ((TakesScreenshot)webDriver).getScreenshotAs(OutputType.FILE);

        // 存入 oss
        String imageUrl = ossUtils.putObject(f);

        //退出
        webDriver.quit();

        return imageUrl;
    }
}
